# $Id: alsa-driver.spec,v 1.27 2002/11/18 11:40:38 dude Exp $

%define	rcver		rc6

# Comma separated list of cards for which to compile a driver
%define	cards		all

%define	kunamer		%(uname -r)
%define	kversion	%(echo $(uname -r) | sed -e s/smp// -)
%if %(uname -r | grep -c smp)
	%{expand:%%define ksmp -smp}
%endif
%define	karch		%(rpm -q --qf '%%{arch}' kernel%{?ksmp}-%{kversion})
%define	krelver		%(echo %{kversion} | tr -s '-' '_')

Summary: The Advanced Linux Sound Architecture (ALSA) base files.
Name: alsa-driver
Version: 0.9.0
Release: fr0%{rcver}.1
License: GPL
Group: System Environment/Base
Source0: ftp://ftp.alsa-project.org/pub/driver/alsa-driver-%{version}%{rcver}.tar.bz2
Source1: alsa-makedev.d.txt
Patch1: alsa-driver-makefile.patch
Patch2: alsa-driver-depmod.patch
URL: http://www.alsa-project.org/
BuildRoot: %{_tmppath}/%{name}-%{version}-root
BuildArch: %{karch}
Requires: alsa-kernel = %{version}, /sbin/depmod
BuildRequires: kernel-source = %{kversion}, MAKEDEV

%description
The Advanced Linux Sound Architecture (ALSA) provides audio and MIDI
functionality to the Linux operating system. ALSA has the following
significant features: Efficient support for all types of audio interfaces,
from consumer soundcards to professional multichannel audio interfaces,
fully modularized sound drivers, SMP and thread-safe design, user space
library (alsa-lib) to simplify application programming and provide higher
level functionality as well as support for the older OSS API, providing
binary compatibility for most OSS programs.

This package contains the ALSA /dev entries and basic development files.

Available rpmbuild rebuild options :
--without : isapnp sequencer oss


%package -n alsa-kernel%{?ksmp}
Summary: The Advanced Linux Sound Architecture (ALSA) kernel drivers.
Release: %{release}_%{krelver}
Group: System Environment/Kernel
Requires: kernel%{?ksmp} = %{kversion}
%{?ksmp:Provides: alsa-kernel = %{version}}

%description -n alsa-kernel%{?ksmp}
The Advanced Linux Sound Architecture (ALSA) provides audio and MIDI
functionality to the Linux operating system. ALSA has the following
significant features: Efficient support for all types of audio interfaces,
from consumer soundcards to professional multichannel audio interfaces,
fully modularized sound drivers, SMP and thread-safe design, user space
library (alsa-lib) to simplify application programming and provide higher
level functionality as well as support for the older OSS API, providing
binary compatibility for most OSS programs.

This package contains the ALSA kernel modules for the Linux kernel package :
%{kversion} (%{karch}%{?ksmp:, SMP}).


%prep
%setup -q -n %{name}-%{version}%{rcver}
%patch1 -p1 -b .buildnonroot
%patch2 -p1 -b .nodepmod

%build
%configure \
	%{?_without_isapnp:--with-isapnp=no} \
	%{?_without_sequencer:--with-sequencer=no} \
	%{?_without_oss:--with-oss=no} \
	--with-cards=%{cards}
make

%install
rm -rf %{buildroot}

mkdir -p %{buildroot}/etc/rc.d/init.d/
make DESTDIR=%{buildroot} install

# Install and generate all the device stuff
install -m 644 -D %{SOURCE1} %{buildroot}%{_sysconfdir}/makedev.d/alsa
cp -a %{_sysconfdir}/makedev.d/00macros %{buildroot}%{_sysconfdir}/makedev.d/
rm -f devices

# Create device link and entry list
mkdir -p %{buildroot}/dev
ln -s /proc/asound/dev %{buildroot}/dev/snd
/dev/MAKEDEV \
	-c %{buildroot}%{_sysconfdir}/makedev.d \
	-d %{buildroot}/dev -M alsa | sed 's|%{buildroot}||g' > device.list

# Remove from the included docs
rm -f doc/Makefile

# Remove for default rpm 4.1 to not fail
rm -f %{buildroot}%{_sysconfdir}/makedev.d/00macros
rm -f %{buildroot}/etc/rc.d/init.d/alsasound

%post -n alsa-kernel%{?ksmp}
/sbin/depmod -a >/dev/null 2>&1 || :

%postun -n alsa-kernel%{?ksmp}
/sbin/depmod -a >/dev/null 2>&1 || :

%clean
rm -rf %{buildroot}

%files -f device.list
%defattr(-, root, root)
%doc CARDS-STATUS COPYING FAQ README TODO WARNING
%doc doc/ alsa-kernel/Documentation/
/dev/snd
%{_sysconfdir}/makedev.d/alsa
%{_includedir}/sound

%files -n alsa-kernel%{?ksmp}
%defattr(-, root, root)
/lib/modules/%{kunamer}/kernel/sound

%changelog
* Mon Nov 16 2002 Matthias Saou <matthias.saou@est.une.marmotte.net>
- Update to 0.9.0rc6.

* Fri Oct 25 2002 Matthias Saou <matthias.saou@est.une.marmotte.net>
- Silent the %%post and %%postun scriplets to avoid unresolved symbol
  warnings during upgrades.

* Wed Oct 23 2002 Matthias Saou <matthias.saou@est.une.marmotte.net>
- Update to 0.9.0rc4, then rc5.

* Tue Oct  1 2002 Matthias Saou <matthias.saou@est.une.marmotte.net>
- Removed the dependency about alsa-driver in alsa-kernel to fix apt problems.

* Sun Sep 29 2002 Matthias Saou <matthias.saou@est.une.marmotte.net>
- Added -smp to alsa-kernel packages for SMP systems (needs testing).

* Fri Sep 27 2002 Matthias Saou <matthias.saou@est.une.marmotte.net>
- Moved rpmbuild --without options to the description.
- Rebuild for Red Hat Linux 8.0.
- Fixed the /sbin/depmod -a that was run for the wrong sub-package, doh!

* Tue Sep 17 2002 Matthias Saou <matthias.saou@est.une.marmotte.net>
- Fixed yet another (last?) bug on SMP systems.

* Sun Sep  8 2002 Matthias Saou <matthias.saou@est.une.marmotte.net>
- Fixed build on SMP systems, thanks to Chris Ckloiber.

* Thu Aug 29 2002 Matthias Saou <matthias.saou@est.une.marmotte.net>
- Fixed extra files problem with rpm 4.1.
- Added support for disabling isapnp, sequencer and oss.
- Added support to easily modify to build only drivers for specific cards.
- Simplified the device list creation ("alsa" alias in the makedev.d entry).
- Fixed reversed links in the /dev entries.

* Wed Aug 28 2002 Matthias Saou <matthias.saou@est.une.marmotte.net>
- Fix the makedev file that didn't like the CVS tag.
- New sub-package -kernel with only the kernel module (to have multiple
  installations of it easily).
- Fixed kernel arch detection by invoking rpm to query kernel package ;-)

* Tue Aug 27 2002 Matthias Saou <matthias.saou@est.une.marmotte.net>
- Spec file rewrite.
- Added makedev.d stuff to have device files included cleanly.

